<?php

/**************************************************************************
**  (c) Copyright 2003, Andromeda Technology & Automation
** This is free software; you can redistribute it and/or modify it under the
** terms of the GNU General Public License, see the file COPYING.
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : objects.php
**      SYSTEM NAME    : Gnucomo - Gnu Computer Monitoring
**      VERSION NUMBER : $Revision: 1.6 $
**
**  DESCRIPTION      : Objects Administration page.
**                     Input parameters: action (POST) : empty, 'Create'
**                                      objname (POST) : name of the object to create or remove
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Dec 04, 2002
**      LAST UPDATE     : Feb 14, 2003
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: objects.php,v $
   Revision 1.6  2003/02/21 08:46:58  arjen
   Improved the table layout.

   Revision 1.5  2003/02/13 09:01:29  arjen
   All web interface pages use the page class.

   Revision 1.4  2003/02/13 08:48:23  arjen
   Added log, notification and parameter counters to the 'object' table.
   Counting these things at the time a user interface needs them is
   too slow. Other programs, like gcm_daemon en gcm_input should prepare
   these counters for quick retrieval.

   Revision 1.3  2003/02/10 15:42:24  arjen
   Show the total number of Log entries, parameters and notifications

   Revision 1.2  2003/02/05 09:48:14  arjen
   Added display and handling of notifications

******************************/

// RCSID = "$Id: objects.php,v 1.6 2003/02/21 08:46:58 arjen Exp $";

ini_set('include_path', '.:./classes:../phpclasses');

require_once('page.class.php');

function clientscripts()
{
?>

<script language='JavaScript'>

function CheckCreate(f)
{
   if (f.objectname.value == "")
   {
      alert("You must supply a name");
      return false;
   }
   return true;
}

function CheckRemove(f)
{
   var message = "Are you sure you want to remove object ";
   message += f.objectname.value;
   message += " ?";

   return confirm(message);
}

</script>

<?php
}

class object_page extends page
{

   function Body()
   {
      clientscripts();

   echo "<h1>Objects Administration</h1><hr>";

   if (isset($_POST['action']) && $_POST['action'] == 'Create' && !empty($_POST['objectname']))
   {
      pg_exec($this->database, "INSERT INTO object (objectname, log_count, parameter_count, notification_count)
                               VALUES ('" . $_POST['objectname'] . "', '0', '0', '0')");
   }

   if (isset($_POST['action']) && $_POST['action'] == 'Remove' && !empty($_POST['objectname']))
   {
      pg_exec($this->database, "DELETE FROM object WHERE objectname='" . $_POST['objectname'] . "'");
   }

   $res = pg_exec($this->database, "SELECT objectid,objectname, log_count, notification_count
                                    FROM object ORDER BY objectname");
?>

   <table>
   <tr><th>Object</th><th>Log entries</th>
       <th>Parameters</th><th>Notifications</th>
   </tr>

<?php
   $obj = 0;

   //The counters are set to zero
   $count_logs = 0;
   $count_notifications = 0;
   $count_parameters = 0;

   while ($obj < pg_numrows($res))
   {
      $u = pg_fetch_object($res, $obj);
      $nr_logs = $u->log_count;
      $count_logs = $count_logs + $nr_logs;

      $r = pg_exec ($this->database, "SELECT count(paramid) FROM parameter WHERE objectid=CAST('"
                           . $u->objectid . "' AS BIGINT)");
      $r = pg_fetch_object($r, 0);

      $nr_params = $r->count;
      $count_parameters = $count_parameters + $nr_params;

      $nr_notifications = $u->notification_count;
      $count_notifications = $count_notifications + $nr_notifications;
      ?>
      <tr><td><center><img src='server.png'><br>
             <b><?php echo $u->objectname ?></b></center>
      </td><td class='number'>
          <?php echo "<a href='log.php?oid=$u->objectid'> $nr_logs </a>" ?>
      </td><td class='number'>
          <?php echo "<a href='parameter.php?oid=$u->objectid'> $nr_params </a>" ?>
      </td><td class='number'>
          <?php echo "<a href='notification.php?oid=$u->objectid'> $nr_notifications </a>" ?>
      </td><td>
          <form action='objects.php' method='post' onSubmit='return CheckRemove(this)'>
              <input type='hidden' name='objectname' value='<?php echo $u->objectname ?>'>
              <input type='submit' name='action' value='Remove'>
          </form>
      </td></tr>
      <?php
      $obj++;
   }

   //Show the totals
   echo "<tr><td><strong><B><br><br>TOTALS</B></strong></td>";
   echo "<td class='number'>$count_logs</td>";
   echo "<td class='number'>$count_parameters</td>";
   echo "<td class='number'>$count_notifications</td></tr>";
   echo "</table>";

?>

<h2>Create new object:</h2>
<p>

<form action='objects.php' method='post' onSubmit='return CheckCreate(this)'>
Objects name (FQDN): <input name='objectname' type='text'>
<br>
<input type='submit' name='action' value='Create'>
</form>
</p>
<?php

   }
}

$obj_page = new object_page("Gnucomo Objects Administration");

$obj_page->Showpage();

?>

